/*global fv_player_editor_matcher, fv_wp_flowplayer_shortcode_parse_arg, fv_wp_flowplayer_shortcode_write_arg */

if (typeof(fv_player_editor_matcher) !== 'undefined') {
  fv_player_editor_matcher.youtube = {
    matcher: /(youtube\.com|youtu\.be|youtube\-nocookie\.com)\/(shorts\/)?(watch\?(.*&)?v=|v\/|u\/|embed\/?)?(videoseries\?list=(.*)|[\w-]{11}|\?listType=(.*)&list=(.*))(.*)/i,
    update_fields: ['duration', 'caption', 'splash', 'auto_splash', 'auto_caption', 'last_video_meta_check']
  };

  fv_player_editor_matcher.vimeo = {
    matcher: /.+vimeo\.com\/(.*\/)?([\d]+)(.*)?/i,
    update_fields: ['duration', 'caption', 'splash', 'auto_splash', 'auto_caption', 'last_video_meta_check', 'chapters'],
    support_thumb_generate: true
  };

  fv_player_editor_matcher.ok_ru = {
    matcher: /ok\.ru\/video\/\d+/i,
    update_fields: ['duration', 'caption', 'splash', 'auto_splash', 'auto_caption'],
  };

  fv_player_editor_matcher.odysee = {
    matcher: /odysee\.com\/@.*?:.*?\/.*?:./i,
    update_fields: ['duration', 'caption', 'splash', 'auto_splash', 'auto_caption'],
  };

  fv_player_editor_matcher.rumble = {
    matcher: /rumble\.com\/.*?-.*?\.html/i,
    update_fields: ['duration', 'caption', 'splash', 'auto_splash', 'auto_caption'],
  };

  fv_player_editor_matcher.peertube = {
    matcher: /\/w\/\w+/,
    update_fields: ['duration', 'caption', 'splash', 'auto_splash', 'auto_caption'],
  }
}

jQuery(document).trigger('fv_player_matchers_loaded');

jQuery(document).on('fv_flowplayer_shortcode_new', function() {
  jQuery('[name=fv_wp_flowplayer_field_start]').val('');
  jQuery('[name=fv_wp_flowplayer_field_end]').val('');
  jQuery('.fv_wp_flowplayer_hlskey_decoder').hide();

  jQuery('#fv_player_shortcode_editor_qualities_sample').html('Make sure your video is using the quality prefixes from your settings.');
});

jQuery(document).on('fv_flowplayer_shortcode_parse', function(e, shortcode) {
  
  document.getElementById("fv_wp_flowplayer_field_start").value = '';
  document.getElementById("fv_wp_flowplayer_field_end").value = '';
  document.getElementById("fv_wp_flowplayer_hlskey").value = '';  
  
  document.getElementById("fv_wp_flowplayer_field_qsel").checked = 0;
  jQuery('#fv_player_shortcode_editor_qualities_sample').html('Make sure your video is using the quality prefixes from your settings.');
  
  document.getElementById("fv_wp_flowplayer_field_ab").checked = 0;
  
  var fv_wp_fp_shortcode_remains = fv_player_editor.get_shortcode_remains();
  
  var sQSel = shortcode.match( /qsel="(.*?)"/ );
  if( sQSel && typeof(sQSel) != "undefined" && typeof(sQSel[1]) != "undefined" ){
    sQSel = sQSel[1];
    fv_wp_fp_shortcode_remains = fv_wp_fp_shortcode_remains.replace( /qsel="(.*?)"/, '' );            
    if( sQSel && sQSel == "true" ) {
      document.getElementById("fv_wp_flowplayer_field_qsel").checked = 1;
    }
  }
  
  var sAB = shortcode.match( /ab="(.*?)"/ );
  if( sAB && typeof(sAB) !== "undefined" && typeof(sAB[1]) !== "undefined" ){
    sAB = sAB[1];
    fv_wp_fp_shortcode_remains = fv_wp_fp_shortcode_remains.replace( /ab="(.*?)"/, '' );            
    if( sAB && sAB == "true" ) {
      document.getElementById("fv_wp_flowplayer_field_ab").selectedIndex = 1;
    }else if(sAB && sAB == "false"){
      document.getElementById("fv_wp_flowplayer_field_ab").selectedIndex = 2;
    }else{
      document.getElementById("fv_wp_flowplayer_field_ab").selectedIndex = 0;
    }
  }  
  
  document.getElementById("fv_wp_flowplayer_field_hflip").checked = 0;
  var sHflip = shortcode.match( /hflip="(.*?)"/ );
  if( sHflip && typeof(sHflip) !== "undefined" && typeof(sHflip[1]) !== "undefined" ){
    sHflip = sHflip[1];
    fv_wp_fp_shortcode_remains = fv_wp_fp_shortcode_remains.replace( /hflip="(.*?)"/, '' );            
    if( sHflip && sHflip == "true" ) {
      document.getElementById("fv_wp_flowplayer_field_hflip").checked = 1;
    }
  }
  
  document.getElementById("fv_wp_flowplayer_field_copy_text").checked = 0;
  var sCopyText = shortcode.match(/copy_text="(.*?)"/);
  if (sCopyText && typeof (sCopyText) !== "undefined" && typeof (sCopyText[1]) !== "undefined") {
    sCopyText = sCopyText[1];
    fv_wp_fp_shortcode_remains = fv_wp_fp_shortcode_remains.replace(/copy_text="(.*?)"/, '');
    if (sCopyText && sCopyText === "true") {
      document.getElementById("fv_wp_flowplayer_field_copy_text").checked = 1;
    }
  }
  
  jQuery('#fv_wp_flowplayer_field_video_ads').prop('selectedIndex',0);
  var sAds = shortcode.match( /(?:ads|preroll)="(.*?)"/i ), iAds = 0;

  if( sAds && typeof(sAds) !== "undefined" && typeof(sAds[1]) !== "undefined" ){
    sAds = sAds[1];
    iAds = parseInt(sAds);
    fv_wp_fp_shortcode_remains = fv_wp_fp_shortcode_remains.replace( /(ads|preroll)="(.*?)"/, '' );  
    if( sAds && sAds === "random" ) {
      document.getElementById("fv_wp_flowplayer_field_video_ads").selectedIndex = 2;
    } else if( sAds && sAds === "no" ) {
      document.getElementById("fv_wp_flowplayer_field_video_ads").selectedIndex = 1;
    } else if( sAds && iAds > 0 ) {
      document.getElementById("fv_wp_flowplayer_field_video_ads").selectedIndex = 2 + iAds;
    }
  }
  
  jQuery('#fv_wp_flowplayer_field_video_ads_post').prop('selectedIndex',0);
  var sAds = shortcode.match( /postroll="(.*?)"/ ), iAds = 0;
  
  if( sAds && typeof(sAds) != "undefined" && typeof(sAds[1]) != "undefined" ){
    sAds = sAds[1];
    iAds = parseInt(sAds);
    fv_wp_fp_shortcode_remains = fv_wp_fp_shortcode_remains.replace( /postroll="(.*?)"/, '' );            
    if( sAds && sAds == "random" ) {
      document.getElementById("fv_wp_flowplayer_field_video_ads_post").selectedIndex = 2;
    } else if( sAds && sAds == "no" ) {
      document.getElementById("fv_wp_flowplayer_field_video_ads_post").selectedIndex = 1;
    } else if( sAds && iAds > 0 ) {
      document.getElementById("fv_wp_flowplayer_field_video_ads_post").selectedIndex = 2 + iAds;
    }
  }
  var hlskey = fv_wp_flowplayer_shortcode_parse_arg( shortcode, 'hlskey' );
  if(hlskey){
    document.getElementById("fv_wp_flowplayer_hlskey").value = hlskey[1];
  }
  
  fv_wp_flowplayer_shortcode_parse_arg( shortcode, 'startend', false, fv_wp_flowplayer_start_end_parse_arg );
  fv_wp_flowplayer_shortcode_parse_arg( shortcode, 'chapters', false, fv_wp_flowplayer_chapters_parse_arg );
  fv_wp_flowplayer_shortcode_parse_arg( shortcode, 'transcript', false, fv_wp_flowplayer_transcript_parse_arg );

  fv_wp_flowplayer_shortcode_parse_arg( shortcode, 'start',false, fv_wp_flowplayer_start_end_parse_arg);
  fv_wp_flowplayer_shortcode_parse_arg( shortcode, 'end' , false, fv_wp_flowplayer_start_end_parse_arg);

  /*if( sloop != null && sloop[1] != null && sloop[1] == 'true' )
    document.getElementById("fv_wp_flowplayer_field_lightbox").checked = 1;*/
  
  fv_player_editor.set_shortcode_remains( fv_wp_fp_shortcode_remains );
  
} );

jQuery(document).on('fv_flowplayer_shortcode_create', function() {
  var fv_wp_fp_shortcode = '';
  if( document.getElementById("fv_wp_flowplayer_field_hflip").checked ) {
    fv_wp_fp_shortcode += ' hflip="true"';
  }
  if( document.getElementById("fv_wp_flowplayer_field_qsel").checked ) {
    fv_wp_fp_shortcode += ' qsel="true"';
  }
  if( document.getElementById("fv_wp_flowplayer_field_copy_text").checked ) {
    fv_wp_fp_shortcode += ' copy_text="true"';
  }
  
  fv_wp_flowplayer_shortcode_write_arg('fv_wp_flowplayer_field_ab',  'ab',  false, false, ['true','false'] );
  fv_wp_flowplayer_shortcode_write_arg('fv_wp_flowplayer_field_video_ads',      'preroll',  false, false, ['no','random','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16'] );
  fv_wp_flowplayer_shortcode_write_arg('fv_wp_flowplayer_field_video_ads_post', 'postroll', false, false, ['no','random','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16'] );
  
  var aStartEnd = [];
  jQuery('[name=fv_wp_flowplayer_field_start]').each(function(e){
    aStartEnd.push(jQuery(this).val()+'-'+jQuery('[name=fv_wp_flowplayer_field_end]:eq('+e+')').val());
  });
  var sStartEnd = aStartEnd.join(';');
  if(sStartEnd.match(/[0-9]/)){
    fv_wp_fp_shortcode += ' startend="' + sStartEnd + '"';
  }
  
  var aChapters = [];
  jQuery('[name=fv_wp_flowplayer_field_chapters]').each(function(){
    aChapters.push(jQuery(this).val());
  });
  
  var sChapters = aChapters.join(';');
  if(sChapters.match(/[a-zA-Z0-9]/)){
    fv_wp_fp_shortcode += ' chapters="' + sChapters + '"';
  }
  
  fv_wp_flowplayer_shortcode_write_arg('fv_wp_flowplayer_hlskey',  'hlskey');

} );


setInterval( function() {
  if( !fv_player_editor_pro.video_qualities || document.getElementById("fv_wp_flowplayer_field_src") == null ) return;
  
  var sURL = document.getElementById("fv_wp_flowplayer_field_src").value,
    video_qualities = fv_player_editor_pro.video_qualities;
  
  if( sURL ) {
    var sQualityHint = '';
    var sMatched = '';
    for( var i in video_qualities ){
      if( sURL.match(i) ) {
        sQualityHint = 'Your primary video matches '+video_qualities[i]+' quality. Make sure following is available: <ul>';
        sMatched = i;
      }
    }
      
    for( var i in video_qualities ){
      if( i == sMatched ) continue;
      sQualityHint += '<li>'+video_qualities[i]+': <strong>'+sURL.replace(sMatched,i)+'</strong></li>';
    }
    sQualityHint += '</ul>';
    
    if( !sMatched ){
      sQualityHint = "Your primary video is not matching the quality prefixes!";    
      if( document.getElementById("fv_wp_flowplayer_field_qsel").checked ) {
        jQuery('#fv_player_shortcode_editor_qualities_sample_wrap').show();
      }
    }
    jQuery('#fv_player_shortcode_editor_qualities_sample').html(sQualityHint);
  }

  if( document.getElementById("fv_wp_flowplayer_field_qsel").checked ) {

  }

}, 250 );

function fv_wp_flowplayer_start_end_parse_arg(args) {  
  /*legacy*/
  if(args[0].match(/^start=/)){
    jQuery('[name=fv_wp_flowplayer_field_start]:eq(0)').val(args[1].trim());
    return;
  }
  if(args[0].match(/^end=/)){
    if(args[1].trim().match(/-/)){
      return;
    }
    jQuery('[name=fv_wp_flowplayer_field_end]:eq(0)').val(args[1].trim());
    return;
  } 
  /*end legacy*/
  
  var item;
  args = args[1].split(';');
  for (item in args) {
    args[item] = args[item].split('-');
    if (typeof (args[item][0]) !== 'undefined')
      jQuery('[name=fv_wp_flowplayer_field_start]:eq(' + item + ')').val(args[item][0].trim()).parents('tr').show();
    if (typeof (args[item][1]) !== 'undefined')
      jQuery('[name=fv_wp_flowplayer_field_end]:eq(' + item + ')').val(args[item][1].trim()).parents('tr').show();
  }
}

function fv_wp_flowplayer_chapters_parse_arg(args) {
  var item;
  args = args[1].split(';');
  for (item in args) {
    if (typeof (args[item]) !== 'undefined')
      jQuery('[name=fv_wp_flowplayer_field_chapters]:eq(' + item + ')').val(args[item].trim());
  }
}

function fv_wp_flowplayer_transcript_parse_arg(args) {
  var item;
  args = args[1].split(';');
  for (item in args) {
    if (typeof (args[item]) !== 'undefined')
      jQuery('[name=fv_wp_flowplayer_field_transcript]:eq(' + item + ')').val(args[item].trim());
  }
}

jQuery(document).ready(function () {
  
  // parse start time from YouTube links
  jQuery(document).on('keyup', '[name=fv_wp_flowplayer_field_src]', function () {
    var time = jQuery(this).val().match(/(?:vimeo|youtu).*[#?&]t=((?:\d*[hms]?){1,3})/);
    var field = jQuery(this).parents('table').find('#fv_wp_flowplayer_field_start');
    if(time && field.length){
      time = time[1].replace(/[hm]/g,':').replace(/s/,'');//.replace(/[\^^](\d{1})/g,'0$1');
      field.val(time).parents('tr').show();
      jQuery(this).val( jQuery(this).val().replace(/(\?|&|#)t=((?:\d*[hms]?){1,3})&?/,'$1').replace(/(#|&)$/,'') ); //  https://www.youtube.com/watch?t=123&v=kH6QJzmLYtw OR https://www.youtube.com/watch?v=kH6QJzmLYtw&t=123 TO https://www.youtube.com/watch?v=kH6QJzmLYtw and also https://vimeo.com/258828793?title=0&byline=0&portrait=0#t=01m46s
    }
  });
  
  // show or hide interface for HLS key
  function hls_decoder_show_hide(e,index) {
    var src = jQuery(this).val(),
      item = jQuery(this).parents('table');
    
    if( typeof(index) != "undefined" ) {
      item = jQuery('.fv-player-playlist-item[data-index='+index+']');
      src = item.find('[name=fv_wp_flowplayer_field_src]').val();
    }
    
    var hls_row = item.find('.fv_wp_flowplayer_hlskey_decoder');
    if( src.match(/m3u8/) ) {
      hls_row.show();
    } else {
      hls_row.hide();
    }
    
    jQuery('.fv_wp_flowplayer_hlskey_encrypted').hide();
  }
  
  jQuery(document).on('keyup', '[name=fv_wp_flowplayer_field_src]', hls_decoder_show_hide );
  jQuery(document).on('fv_flowplayer_shortcode_item_switch', hls_decoder_show_hide );
  
  // show the HLS key decryption tool
  jQuery(document).on('click','[name=fv_wp_flowplayer_hlskey]', function() {
    jQuery(this).next().slideDown();
  });
  
  // HLS key decryption action
  jQuery(document).on('click', '#button-hls-decrypt', function(){
    var
      $that = jQuery(this),
      $crypt_textarea = jQuery(this).prevAll('#fv_wp_flowplayer_hlskey_cryptic:first'),
      $crypt_key = jQuery(this).parents('.fv_wp_flowplayer_hlskey_decoder').find('#fv_wp_flowplayer_hlskey'),
      $label = $that.find('.label');

    $label.html('Decrypting...');
    jQuery.post(ajaxurl, { action: 'fv_fp_decrypt_hlskey', cryptic: $crypt_textarea.val() },
      function (response) {
        $label.html('Decrypt');
        if (response.length == 24) {
          $crypt_key.val(response);
        } else if (response == 'php') {
          alert('Please check Your PHP version');
        } else if (response == 'cryptic') {
          alert('Please check Your Cryptic key');
        } else if (response == 'settings') {
          alert('Please check Your Amazon Credentials an Region in plugin settings');
        } else {
          alert(response);
        }
      }).fail(function() {
        $label.html('Decrypt');
        alert( "Please check Your Amazon Credentials And crypic Key" );
      });

    return false;
  });

})

function fv_player_shortcode_editor_qs(args) {
  jQuery('#fv_player_shortcode_editor_qualities_sample_wrap').toggle(400, function() {
    if( typeof(fv_player_editor.fv_wp_flowplayer_dialog_resize) == "function") fv_player_editor.fv_wp_flowplayer_dialog_resize();
  });
  return false;
}

(function ($) {
  ('use strict');

  jQuery(document).on('fv_flowplayer_video_meta_save', function(event, data, element_data_index, element) {
    // check if this is a HLS input
    if (element.id != 'fv_wp_flowplayer_hlskey') {
      return;
    }

    // prepare HLS data, if not prepared yet
    if (!data['video_meta']['hls']) {
      data['video_meta']['hls'] = {};
    }

    if (!data['video_meta']['hls'][element_data_index]) {
      data['video_meta']['hls'][element_data_index] = {};
    }

    // handle hslkey metadata for each video
    fv_flowplayer_insertUpdateOrDeleteVideoMeta({
      data: data,
      meta_section: 'hls',
      meta_key: 'hlskey',
      meta_index: element_data_index,
      element: element
    });
  });

  jQuery(document).on('fv_flowplayer_video_meta_load', function(event, element_meta_index, metadata, $video_data_tab) {
    var meta_found = false;

    if (metadata) {
      // check if we have any HLS meta data for this player
      for (var i in metadata) {
        if (metadata[i].meta_key == 'hls_hlskey') {
          if (metadata[i].meta_value) {
            meta_found = true;
          }

          $video_data_tab.find('#fv_wp_flowplayer_hlskey')
            .val(metadata[i].meta_value)
            .attr('data-id', metadata[i].id);
        }
      }
    }
  });
}(jQuery));

// Transcript original formating and Timeline previews fieldds
(function ($) {
  ('use strict');

  jQuery(document).on('fv_flowplayer_video_meta_save', function(event, data, element_data_index, element) {
    var meta_key = false;
    if (element.id == 'fv-fp-transcript-checkbox' ) {
      meta_key = 'transcript_original_formatting';
    } else if( element.id == 'fv_wp_timeline_preview') {
      meta_key = 'timeline_previews';
    }
      
    if( !meta_key ) {
      return;
    }

    if (!data['video_meta']['video']) {
      data['video_meta']['video'] = {};
    }

    if (!data['video_meta']['video'][element_data_index]) {
      data['video_meta']['video'][element_data_index] = {};
    }

    fv_flowplayer_insertUpdateOrDeleteVideoMeta({
      data: data,
      meta_section: 'video',
      meta_key: meta_key,
      meta_index: element_data_index,
      element: element
    });
  });

  jQuery(document).on('fv_flowplayer_video_meta_load', function(event, element_meta_index, metadata, $video_data_tab , $subtitles_tab) {
    if (metadata) {
      for (var i in metadata) {
        if (metadata[i].meta_key == 'transcript_original_formatting') {
          $subtitles_tab.find('#fv-fp-transcript-checkbox').prop('checked', metadata[i].meta_value).attr('data-id', metadata[i].id);
        }
        if (metadata[i].meta_key == 'timeline_previews') {
          $subtitles_tab.find('#fv_wp_timeline_preview').val(metadata[i].meta_value).attr('data-id', metadata[i].id);
        }
      }
    }
  });

  // fired up by shortcode-editor in the free player
  //
  // checks whether the URL is not a source of an external playlist and enabled/disables
  // adding new videos into a this player's playlist if this is the first video in the player
  // and is an external playlist already
  jQuery(document).on('fv-player-editor-src-change', function(event, src_input_value, result) {
    // make sure our supported types of videos don't raise a false notice
    if (
      src_input_value.indexOf('vimeo.com') > -1 ||
      src_input_value.indexOf('vimeopro.com') > -1 ||
      src_input_value.indexOf('youtube.com') > -1 ||
      src_input_value.indexOf('youtu.be') > -1
    ) {
      result.supported = true;
    }

    // check how many playlist items we have currently
    var
      playlist_length = fv_player_editor.get_playlist_items_count(),
      is_youtube_playlist = ( (src_input_value.indexOf('youtube.com') > -1 || src_input_value.indexOf('youtu.be') > -1) && src_input_value.indexOf('list=') > -1 ),
      is_vimeo_playlist_style_url = /vimeo(pro)?\.com\/(channels|album|showcase)\/.*/gi.exec( src_input_value );

    // exclude https://vimeo.com/channels/staffpicks/65107797
    if( src_input_value.match(/\/channels\/[^>]+\/\d+/) ) {
      is_vimeo_playlist_style_url = false;
    }

    // make sure that if we're adding a playlist item at the first index position,
    // we hide the "+ Add playlist item" button
    if ( playlist_length == 1 && (is_youtube_playlist || is_vimeo_playlist_style_url) ) {
      jQuery('.playlist_add, .playlist_edit').hide();
    } else {
      jQuery('.playlist_add, .playlist_edit').show();
    }
  });
}(jQuery));